﻿using C1.JsonNet;
using C1.Web.Mvc.Serialization;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace C1MvcWebApplication1.Models
{
    [CollectionItemType(typeof(ExpandoObject), typeof(ExpandoObjectConverter))]
    public class DynamicList : List<dynamic>
    {
    }

    public class ExpandoObjectConverter : C1.JsonNet.JsonConverter
    {
        public override bool CanConvert(Type objectType)
        {
            return objectType == typeof(ExpandoObject);
        }

        protected override void Write(BaseWriter writer, object value, IContext context)
        {
            // convert to IDictionary
            var result = new Dictionary<string, object>();
            var dictionary = value as IDictionary<string, object>;
            foreach (var item in dictionary)
            {
                result.Add(item.Key, item.Value);
            }

            base.Write(writer, result, context);
        }

        protected override string ConvertTo(object value)
        {
            // serialize the IDictionary to string
            return JsonHelper.SerializeObject(value);
        }
    }
}
